/*
	MERVBot Spawn-callback by Catid@pacbell.net
*/

#ifndef SPAWN_H
#define SPAWN_H

#define STRING_CAST_CHAR
#include "..\dllcore.h"

#include "..\clientprot.h"

struct PlayerTag
{
	Player *p;
	int index;
	int data;
};

#define TAG_WARNED		0
#define TAG_TIMER		1
#define TAG_DELAY		2
#define TAG_OFFENSES	3

#define TAG_STAT_W		4
#define TAG_STAT_L		5
#define TAG_STAT_TK		6
#define TAG_STAT_G		7
#define TAG_STAT_FL		8
#define TAG_STAT_FK		9
#define TAG_STAT_FS		10
#define TAG_STAT_FD		11
#define TAG_STAT_FT		12
#define TAG_STAT_KP		13

#define TAG_FLAGTIMER	14

#define NUM_STATS 12
#define NUM_TEAMS 10

class botInfo
{
	bool CONNECTION_DENIED;

	_linkedlist <PlayerTag> taglist;
	int get_tag(Player *p, int index);
	void set_tag(Player *p, int index, int data);
	void killTags(Player *p);
	void killTags();

	CALL_HANDLE handle;
	CALL_COMMAND callback;
	CALL_PLIST playerlist;
	CALL_FLIST flaglist;
	CALL_MAP map;
	char *arena;
	arenaSettings *settings;
	Player *me;
	bool biller_online;

	int countdown[4];

	// Put bot data here

	int radius, delay, warn;
	bool enabled;

	int periodic, jackpot;
	bool jperiodic, jgreet, victory, new_jackpot;

	int warnings, grace, bantime;
	bool teamkill, safekill, skradius;

	int gametime;

	int flagtime;
	bool spamflags;

	int unevenplayers, uneventeams;
	bool checkeventeams;

public:
	botInfo(CALL_HANDLE given)
	{
		handle = given;
		callback = 0;
		playerlist = 0;
		flaglist = 0;
		map = 0;
		countdown[0] = 600;
		countdown[1] = 10;
		countdown[2] = 300;
		countdown[3] = 300;
		CONNECTION_DENIED = false;
		me = 0;
		biller_online = true;
/////////////////////////////
		enabled = false;
		radius = 25;
		delay = 0;
		warn = 1;

		periodic = 10;
		jperiodic = false;
		jgreet = false;
		victory = false;
		jackpot = 0;

		warnings = 2;
		grace = 5;
		teamkill = false;
		safekill = false;
		skradius = false;
		bantime = 10;

		gametime = 0;

		flagtime = 5;
		spamflags = false;

		unevenplayers = 3;
		uneventeams = 2;
		checkeventeams = false;

		new_jackpot = true;
	}

	void WriteIni();

	int getTeamPlayers(int team);

	Player *getPlayer(int ident);

	void gotEvent(BotEvent &event);

	void tell(BotEvent &event);

	bool validate(CALL_HANDLE given) { return given == handle; }

	void sendPrivate(Player *player, char *msg);
	void sendPrivate(Player *player, BYTE snd, char *msg);

	void sendTeam(char *msg);
	void sendTeam(BYTE snd, char *msg);

	void sendTeamPrivate(Uint16 team, char *msg);
	void sendTeamPrivate(Uint16 team, BYTE snd, char *msg);

	void sendPublic(char *msg);
	void sendPublic(BYTE snd, char *msg);

	void sendPublicMacro(char *msg);
	void sendPublicMacro(BYTE snd, char *msg);

	void sendChannel(char *msg);			// #;Message
	void sendRemotePrivate(char *msg);		// :Name:Messsage
	void sendRemotePrivate(char *name, char *msg);

	void gotHelp(Player *p, Command *c);
	void gotCommand(Player *p, Command *c);
	void gotRemoteHelp(char *p, Command *c, Operator_Level l);
	void gotRemote(char *p, Command *c, Operator_Level l);
};


// The botlist contains every bot to ever be spawned of this type,
// some entries may no longer exist.

extern _linkedlist <botInfo> botlist;

botInfo *findBot(CALL_HANDLE handle);


#endif	// SPAWN_H
